<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Text Ad Script v3.07 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : TAGAX-307-FTV
// URL : http://www.phpkobo.com/text_ad.php
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CBend_cell extends CBend_crud {

	public function init() {
		$this->tbl_name = "cell";
		$this->id_name = "cell_id";
		parent::init();

		$this->bind("hd_search");
		$this->bind("hd_edit_inp");
		$this->bind("hd_edit_done");
		$this->bind("hd_reg_inp");
		$this->bind("hd_reg_done");
		$this->bind("hd_del_multi");
		$this->bind("hd_pin");
		$this->bind("hd_copy");
		$this->bind("hd_get_rs");
	}

	public function setupRec( &$rs ) {
		if ( !isset($rs["gname"]) ) {
			$rs["gname"] = ( isset($rs["username"]) ) ?
				$rs["username"] : "";
		}
	}

	public function pc_search( $data ) {

		//-- select clause
		$sx = array(
			$this->id_name,
			"cell.dt_create",
			"cell.group_id",
			"cell.pinidx",
			"cell.title",
			"cell.notes",
		);
		if ( CUG::isAdmin() ) {
			$sx[] = "user.username";
		}

		$data->clx[] = CSql::clSelect($sx);

		//-- from clause
		$fromx = array();
		$fromx[] = CSql::clFrom($this->tbl_name);
		$fromx[] = CSql::clLeftJoin("user","group_id",
			$this->tbl_name,"group_id");
		$data->clx[] = implode("\n",$fromx);

		//-- where clause
		$cond = array();

		//-- search criteria
		$criteria = $data->requ["criteria"];
		$keyword = $criteria["keyword"];

		if ( $keyword != "" ) {
			$cond2 = array();
			$cond2[] = CSql::clCond("cell.title","L%%",$keyword);
			$cond2[] = CSql::clCond("cell.notes","L%%",$keyword);
			if ( CUG::isAdmin() ) {
				$cond2[] = CSql::clCond("user.username","=",$keyword);
			}
			$cond[] = CSql::clCondOp("OR",$cond2);
		}
		$this->addGroupIdCond( $cond );
		if ( count($cond) > 0  ) {
			$data->clx[] = CSql::clWhere("AND",$cond);
		}
	}

	protected function validate( $data ) {

		//-- locale
		$lca = CEnv::locale( $this->tbl_name."/validate" );

		//-- vali macro
		CValiMacro::setup($data, $lca);
		if ( $data->cmd == "reg_done" ) {
			CValiMacro::vStr("title");
		} else {
			CValiMacro::vCheckbox("pinidx");
			CValiMacro::vStr("title");
			CValiMacro::vStr("edtype");
			CValiMacro::vStr("txt",false);
			CValiMacro::vStr("notes",false);
			CValiMacro::vCheckbox("preview");
		}
	}

	public function pc_edit_inp( $data ) {

		//-- select clause
		$sx = array(
			$this->id_name,
			"cell.dt_create",
			"cell.group_id",
			"cell.pinidx",
			"cell.title",
			"cell.edtype",
			"cell.txt",
			"cell.notes",
			"cell.preview",
		);
		$data->clx[] = CSql::clSelect($sx);

		//-- from clause
		$fromx = array();
		$fromx[] = CSql::clFrom($this->tbl_name);
		$fromx[] = CSql::clLeftJoin("user","group_id",
			$this->tbl_name,"group_id");
		$data->clx[] = implode("\n",$fromx);

		//-- return subcmd
		$data->resp['subcmd'] = $data->requ["subcmd"];
	}

	public function pc_edit_done_after_save( $data ) {
		CCache::init();
		CCache::save($data->id,array("txt"=>$data->vx["txt"]));
	}

	public function pc_reg_done_validate( $data ) {

		$data->vx["preview"] = 1;
		$cfg = CCfgDb::get("cfgapp");
		$data->vx["edtype"] = $cfg["tbl:cell:default-edtype"];

		//-- dt_create, user_id, group_id
		$data->vx["dt_create"] = gmdate("Y-m-d H:i:s");
		$data->vx["user_id"] = CSess::getUserInfo("user_id");
		$data->vx["group_id"] = CSess::getUserInfo("group_id");

		return true;
	}

	public function pc_copy( $data ) {

		//-- locale
		$lca = CEnv::locale( $this->tbl_name."/validate" );

		//-- vali macro
		CValiMacro::setup($data, $lca);
		CValiMacro::vStr("title");
		CValiMacro::vInt("group_id");
		if ( !CFRes::isValidated() ) {
			return false;
		}

		if (!($rs = $this->getRec($data))) {
			return false;
		}

		//-- rearrange data
		unset($rs["cell_id"]);
		$rs["dt_create"] = gmdate("Y-m-d H:i:s");
		$rs["title"] = $data->vx["title"];
		$rs["user_id"] = CSess::getUserInfo("user_id");
		$rs["group_id"] = $data->vx["group_id"];
		$data->vx = $rs;

		return true;
	}

}

?>