<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Text Ad Script v3.07 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : TAGAX-307-FTV
// URL : http://www.phpkobo.com/text_ad.php
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CBend_cfgapp extends CBend_crud {

	public function init() {
		$this->bind("hd_save");
		$this->bind("hd_clear_cache");
		$this->bind("hd_clear_cache_exe");
	}

	private function validate( $data ) {

		//-- locale
		$lca_key = "cfgapp/validate";
		$lca = CEnv::locale( $lca_key );

		//-- vali macro
		CValiMacro::setup($data, $lca);
		CValiMacro::vCheckbox("b-cache");
		CValiMacro::vInt("tbl:user:default-page-size");
		CValiMacro::vStr("tbl:user:default-sort-val");
		CValiMacro::vInt("tbl:cell:default-page-size");
		CValiMacro::vStr("tbl:cell:default-sort-val");
		CValiMacro::vStr("tbl:cell:default-edtype");
	}

	public function hd_save( $data ) {
		$data->vx = array();
		$data->fm = $data->requ["form"];

		//-- validate
		$this->validate( $data );
		if ( !CFRes::isValidated() ) {
			CFRes::ret($data);
			return;
		}

		//-- set cache state
		CCache::init();
		CCache::setCacheState( $data->vx["b-cache"] );
		unset( $data->vx["b-cache"] );

		//-- save to db
		CDb::open();
		CCfgDb::set( "cfgapp", $data->vx );

		//-- resp
		self::retUpdated( $data );
	}

	public function hd_clear_cache( $data ) {
		//-- get cache count
		CCache::init();
		$total = CCache::getCount();

		//-- build msg
		$lca = CEnv::locale("cfgapp/clear-cache");
		$title = $lca["title"];
		if ( $total == 0 ) {
			$msg = $lca["text:no-files"];
		} else {
			$msg = str_replace("%cnt%",$total,$lca["text:want-to-clear"]);
			$msg = str_replace("%s%",($total!=1)?"s":"",$msg);
		}

		//-- resp
		$data->resp["total"] = $total;
		$data->resp["title"] = $title;
		$data->resp["msg"] = $msg;
		self::ret( $data );
	}

	public function hd_clear_cache_exe( $data ) {
		//-- set cache state
		CCache::init();
		$total = CCache::getCount();

		//-- build msg
		$lca = CEnv::locale("cfgapp/clear-cache");
		$title = $lca["title"];

		list($deleted,$not_deleted) = CCache::deleteAll();

		$msg = $lca["text:deleted"];
		$msg = str_replace("%cnt%",$deleted,$msg);
		$msg = str_replace("%s%",($deleted!=1)?"s":"",$msg);
		if ( $not_deleted ) {
			$msg2 = $lca["text:not-deleted"];
			$msg2 = str_replace("%cnt%",$not_deleted,$msg2);
			$msg2 = str_replace("%s%",($not_deleted!=1)?"s":"",$msg2);
			$msg .= "<br/><br/>{$msg2}";
		}

		//-- resp
		$data->resp["title"] = $title;
		$data->resp["msg"] = $msg;
		self::ret( $data );
	}
}

?>