<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Text Ad Script v3.07 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : TAGAX-307-FTV
// URL : http://www.phpkobo.com/text_ad.php
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CCache_TAGAX_307 {
	
	const CACHE_KEY = "_cache_";
	private static $path_cache;

	public static function init() {
		self::$path_cache = self::pathCache();
	}

	private static function pathCache() {
		$cfg = array();
		include( dirname(dirname(dirname(__FILE__))) .
			"/config/app/config.app.inc.php" );
		return $cfg["path-cache"];
	}

	private static function pathCacheStateFile() {
		return self::$path_cache . self::CACHE_KEY;
	}

	public static function getCacheState() {
		return file_exists( self::pathCacheStateFile() );
	}

	public static function setCacheState( $b_cache ) {
		if ( $b_cache ) {
			@file_put_contents(self::pathCacheStateFile(),"1");
		} else {
			@unlink(self::pathCacheStateFile());
		}
	}

	public static function exists( $id ) {
		return file_exists( self::pathCacheStateFile() . $id );
	}

	public static function load( $id ) {
		return CJson_TAGAX_307::decode(file_get_contents( self::pathCacheStateFile() . $id ));
	}

	public static function save( $id, $rs ) {
		if ( self::getCacheState() && ( $rs ) ) {
			file_put_contents( self::pathCacheStateFile() . $id, CJson_TAGAX_307::encode($rs) );
		} else {
			self::clear( $id );
		}
	}

	public static function clear( $id ) {
		@unlink(self::pathCacheStateFile() . $id);
	}

	public static function getCount() {
		$path = self::pathCache();
		$len = strlen(self::CACHE_KEY);
		$total = 0;
		foreach (glob("{$path}*") as $path) {
			if ( !is_dir($path) ) {
				$path_parts = pathinfo( $path );
				$bn = $path_parts["basename"];

				if (
					( substr($bn,0,$len) == self::CACHE_KEY ) &&
					( strlen($bn) > $len )
				) {
					$total++;
				}
			}
		}
		return $total;
	}

	public static function deleteAll() {
		$path = self::pathCache();
		$len = strlen(self::CACHE_KEY);
		$total = 0;
		foreach (glob("{$path}*") as $path) {
			if ( !is_dir($path) ) {
				$path_parts = pathinfo( $path );
				$bn = $path_parts["basename"];

				if (
					( substr($bn,0,$len) == self::CACHE_KEY ) &&
					( strlen($bn) > $len )
				) {
					@unlink($path);
					$total++;
				}
			}
		}
		$not_deleted = self::getCount();
		return array($total-$not_deleted,$not_deleted);
	}

	public static function checkPermission() {
		$path = self::pathCache();
		return ( is_readable( $path ) && is_writeable( $path ) );
	}
}

?>